#define pset putpixel
#define pget readpixel

void init256(void);
void deinit256(void);
void waitretrace(void);
void putpixel(unsigned int x, unsigned int y, unsigned char color);
unsigned char readpixel(unsigned int x, unsigned int y);
void setpal(unsigned char index, unsigned char rval, unsigned char gval, unsigned char bval);
void readpal(unsigned char index, unsigned char *bytes);
void hline(unsigned int x1, unsigned int x2, unsigned int y, unsigned char color);
void vline(unsigned int x, unsigned int y1, unsigned int y2, unsigned char color);
void fade2black(void);
void stepfadeup(unsigned char index, unsigned char *from, unsigned char *to);


char *VIDEO=(char *)0x0a0000;

#pragma aux init256 = \
"     mov ax,13h      " \
"     int 10h         " \
modify [ax];

#pragma aux deinit256 = \
"mov ax,3h "\
"int 10h"\
modify [ax];

#pragma aux waitretrace = \
"mov dx, 0x3da"\
"l1: in al, dx"\
"and al, 0x08"\
"jnz l1"\
"l2: in al, dx"\
"and al, 0x08"\
"jz l2"\
modify [ax dx];

void putpixel(unsigned int x, unsigned int y, unsigned char color){
        *(VIDEO+(y<<6)+(y<<8)+x)=color;
}

unsigned char readpixel(unsigned int x, unsigned int y){
        unsigned char temp;

        temp=*(VIDEO+(y<<6)+(y<<8)+x);
        return temp;
}

void setpal(unsigned char index, unsigned char rval, unsigned char gval, unsigned char bval){
        outp(0x3c8,index);
        outp(0x3c9,rval);
        outp(0x3c9,gval);
        outp(0x3c9,bval);
}

void readpal(unsigned char index, unsigned char *bytes){
        outp(0x3c7,index);
        *(bytes)=inp(0x3c9);
        *(bytes+1)=inp(0x3c9);
        *(bytes+2)=inp(0x3c9);
}

void hline(unsigned int x1, unsigned int x2, unsigned int y, unsigned char color){
        unsigned int loopvar;

        for(loopvar=x1;loopvar<=x2;loopvar++)
                pset(loopvar,y,color);
}

void vline(unsigned int x, unsigned int y1, unsigned int y2, unsigned char color){
        unsigned int loopvar;
        for(loopvar=y1;loopvar<=y2;loopvar++)
                pset(x,loopvar,color);
}

void fade2black(void){
        unsigned char colors[256][3];
        unsigned int loopvar, loopvar2;

        for(loopvar=0;loopvar<256;loopvar++){
                readpal(loopvar,colors[loopvar]);
        }

        for(loopvar=0;loopvar<64;loopvar++){
                for(loopvar2=0;loopvar2<256;loopvar2++){
                        if(colors[loopvar2][0]>0)colors[loopvar2][0]--;
                        if(colors[loopvar2][1]>0)colors[loopvar2][1]--;
                        if(colors[loopvar2][2]>0)colors[loopvar2][2]--;
                }
                waitretrace();
                for(loopvar2=0;loopvar2<256;loopvar2++){
                        setpal(loopvar2,colors[loopvar2][0],colors[loopvar2][1],colors[loopvar2][2]);
                }
        }
}

void stepfadeup(unsigned char index, unsigned char *from, unsigned char *to){
        if (from[0]<to[0])from[0]++;
        if (from[1]<to[1])from[1]++;
        if (from[2]<to[2])from[2]++;
}
